package com.bwie;

import com.bwie.common.handler.GlobalExceptionHandle;
import com.bwie.common.redis.RedisCache;

import com.bwie.common.remote.RemoteLoginService;
import com.bwie.common.remote.factory.RemoteHouseFactory;
import com.bwie.common.remote.factory.RemoteLoginFactory;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.Import;

@SpringBootApplication(exclude = DataSourceAutoConfiguration.class)
@EnableDiscoveryClient
@EnableFeignClients("com.bwie.**")
@Import({GlobalExceptionHandle.class, RedisCache.class,
        RemoteLoginFactory.class})
public class AuthApp {

    public static void main(String[] args) {

        SpringApplication.run(AuthApp.class,args);

    }

}


