package com.bwie.common.domain;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.Date;
/**
 * 求租表
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
@TableName("askrent")
public class AskRent {
    @TableId(value = "askrent_id",type = IdType.AUTO)
    private Long askRentId;  //求租ID
    @TableField("askrent_address")
    private String askRentAddress;  //求租具体地址
    @TableField("askrent_title")
    private String askRentTitle;  //求租标签
    @TableField("dictionary_type_id")
    private Long dictionaryTypeId;  //求租类型
    @TableField("addr_id")
    private Long addrId;  //三级联动
    @TableField("user_id")
    private Long userId;  //联系人
    @TableField("askrent_price")
    private BigDecimal askRentPrice;  //求租价格
    @TableField("is_delete")
    private Long isDelete;  //逻辑删除
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField("create_time")
    private Date createTime;  //创建时间
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField("update_time")
    private Date updateTime;  //修改时间
}
