package com.bwie.common.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 订单表
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
public class Order {

    private Long ordersId;//订单ID
    private String ordersNumber;//订单编号
    private Long userId;//支付人ID
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyyy-MM-dd HH:mm:ss")
    private Date ordersDate;//支付时间
    private String ordersWay;//支付方式
    private BigDecimal ordersPrice;//支付金额
    private Integer isDelete;//逻辑删除
    private Integer ordersStatus;//订单状态
    private Long houseId;//房源表ID
    private String userTel;//支付人手机号
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyyy-MM-dd HH:mm:ss")
    private Date udpDate;//最新更改订单时间
}
