package com.bwie.common.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;
import java.util.Date;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "user")
public class User {

    /*
        id
     */
    @TableId(type = IdType.AUTO)
    @NotNull(message = "用户Id不能为空")
    private Long userId;
    /*
        姓名
     */
    private String userName;
    /*
        密码
     */
    private String userPassword;
    /*
        手机号
     */
    private String userTel;
    /*
        头像
     */
    private String userImg;
    /*
        公司
     */
    private String company;
    /*
        积分
     */
    private Integer point;
    /*
        状态【0-在职 1-离职】
     */
    private Integer userStatus;
    /*
        登陆人身份【0-经纪人 1-用户】
     */
    private Integer userRole;
    /*
        是否启用【0-启用 1-未启用】
     */
    private Integer isStart;
    /*
        入职时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date createTime;
    /*
        最新修改时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date updateTime;
    /*
        逻辑删除字段
     */
    private Integer isDelete;



}
