package com.bwie.common.domain.request;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("t_group")
public class GroupRequest {
    @TableId
    private Long groupId;        //团购ID
    private String groupTitle;        //团购标题
    private String groupImage;        //图片
    private String groupContent;        //团购内容
    private String groupHouseName;       // 房型名称
    private String groupHouseAddress;        //房型地址
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date startTime;        //开始时间
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date endTime;        //结束时间
    private Long groupStatus;        //团购状态1.已开团2.未开团
    private Long groupEnable;        //是否开启1.是2.否
    private String groupIntroduce;        //详情介绍
    private Long groupNumber;        //开团报名人数
    private String groupAddress;       //集合地址
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date groupTime;        //集合时间
    private String groupLicense;        //车牌号
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;        //创建时间
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;        //修改时间
    private Long isDelete;

    private Integer pageNum=1;
    private Integer pageSize=5;
}
