package com.bwie.common.domain.request;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class HouseEsRequest {
    private Long id;  //主键
    private Long userId;  //发布人id
    private String title;  //标题
    private String estate;  //小区
    private Long houseTypeId;  //发布类型id-- 2手房出售 有房出租 我想买房 租房 帮我找房
    private String houseTypeName; //房产发布类型名称
    private Long addrId;  //区域id
    private String houseAddr;  //房源详细地址
    private Integer dictionaryTypeId; //房产类型字典id
    private String dictionaryTypeName; //房产类型名称
    private BigDecimal housePrice;  //价格
    private String roomType;  //户型
    private String orientation;  //朝向
    private String decorate;  //装修
    private String floor;  //楼层
    private Integer acreage;  //面积
    private String sellingPoints;  //核心卖点
    private String mentality;  //业主心态
    private String serviceIntroduction;  //服务介绍
    private Integer managerStatus;  //房源管理状态
    private Long brokerId;  //经纪人id
    private String brokerName; //经纪人名称
    private Integer isSuccess;  //是否交易成功【0-成功 1-失败】
    private Integer verify;  //是否验真【0-已验真 1-未验真】
    private Integer isEs;  //是否同步es【0-同步 1-未同步】
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;  //创建时间
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;  //最近更新时间
    private Integer isDelete;  //逻辑删除字段

    private List<String> houseImages; //房型图片
}















