package com.bwie.common.remote;

import com.bwie.common.domain.House;
import com.bwie.common.domain.User;
import com.bwie.common.domain.request.HouseEsRequest;

import com.bwie.common.remote.factory.RemoteHouseFactory;
import com.bwie.common.result.Result;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

@FeignClient(
        name = "bwie-home",
        fallbackFactory = RemoteHouseFactory.class,
        path = "/home"
)
public interface RemoteHouseService {
    @GetMapping("/list")
    public Result<List<HouseEsRequest>> getHouseEsList();

    @GetMapping("/shouall")
    public Result<List<House>> shouall();

    @PostMapping("/login")
    Result<User> login(@RequestBody User user);

    @PostMapping("register")
    Result register(@RequestBody User user);
    @GetMapping("/findByPhone/{userTel}")
    Result<User> findByPhone(@PathVariable("userTel") String userTel);
}
