package com.bwie.common.remote;


import com.bwie.common.constant.ServerNameConstants;
import com.bwie.common.domain.User;
import com.bwie.common.domain.request.LoginRequest;
import com.bwie.common.remote.factory.RemoteLoginFactory;
import com.bwie.common.result.Result;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

@FeignClient(
        name = ServerNameConstants.SYSTEM_NAME,
        fallbackFactory = RemoteLoginFactory.class
)
public interface RemoteLoginService {

    @PostMapping("/login")
    Result<User> login(@RequestBody LoginRequest loginRequest);

    @PostMapping("register")
    Result register(@RequestBody User user);

    @GetMapping("/findByPhone/{userTel}")
    Result<User> findByPhone(@PathVariable("userTel") String userTel);

    @PostMapping("/phoneLogin/{userTel}")
    Result<User> phoneLogin(@PathVariable String  userTel);

}
