package com.bwie.common.remote.factory;

import com.bwie.common.domain.House;
import com.bwie.common.domain.User;
import com.bwie.common.domain.request.HouseEsRequest;

import com.bwie.common.remote.RemoteHouseService;
import com.bwie.common.result.Result;
import lombok.extern.log4j.Log4j2;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
@Log4j2
public class RemoteHouseFactory implements FallbackFactory<RemoteHouseService> {
    @Override
    public RemoteHouseService create(Throwable cause) {
        return new RemoteHouseService() {
            @Override
            public Result<List<HouseEsRequest>> getHouseEsList() {
                log.error("远程调用失败：[{}]",cause.getMessage(),cause);
                return Result.error(cause.getMessage());
            }

            @Override
            public Result<List<House>> shouall(){
                log.error("远程调用失败：[{}]",cause.getMessage(),cause);
                return Result.error(cause.getMessage());
            }
            @Override
            public Result<User> login(User user) {
                log.error("登录失败{}",cause.getMessage(),cause);
                return Result.error(cause.getMessage());
            }

            @Override
            public Result register(User user) {
                log.error("注册失败{}",cause.getMessage(),cause);
                return Result.error(cause.getMessage());
            }

            @Override
            public Result<User> findByPhone(String userTel) {
                log.error("查询失败{}",cause.getMessage(),cause);
                return Result.error(cause.getMessage());
            }

        };

    }
}
