package com.bwie.common.remote.factory;

import com.bwie.common.domain.User;
import com.bwie.common.domain.request.LoginRequest;
import com.bwie.common.remote.RemoteLoginService;
import com.bwie.common.result.Result;
import lombok.extern.java.Log;
import lombok.extern.log4j.Log4j2;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

@Component
@Log4j2
public class RemoteLoginFactory implements FallbackFactory<RemoteLoginService> {


    @Override
    public RemoteLoginService create(Throwable cause) {
        return new RemoteLoginService() {
            @Override
            public Result<User> login(LoginRequest loginRequest) {
                log.error("登录失败{}",cause.getMessage(),cause);
                return Result.error(cause.getMessage());
            }

            @Override
            public Result register(User user) {
                log.error("注册失败{}",cause.getMessage(),cause);
                return Result.error(cause.getMessage());
            }

            @Override
            public Result<User> findByPhone(String userTel) {
                log.error("查询失败{}",cause.getMessage(),cause);
                return Result.error(cause.getMessage());
            }

            @Override
            public Result<User> phoneLogin(String userTel) {
                log.error("登录失败{}",cause.getMessage(),cause);
                return Result.error(cause.getMessage());
            }
        };
    }
}
