package com.bwie.alipay.service.impl;


import cn.hutool.core.util.RandomUtil;
import com.alibaba.fastjson2.JSON;
import com.alipay.api.AlipayApiException;
import com.alipay.api.AlipayClient;
import com.alipay.api.DefaultAlipayClient;
import com.alipay.api.AlipayConfig;
import com.alipay.api.domain.AlipayTradePagePayModel;
import com.alipay.api.internal.util.AlipaySignature;
import com.alipay.api.response.AlipayTradePagePayResponse;
import com.alipay.api.request.AlipayTradePagePayRequest;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.bwie.alipay.Alipay;
import com.bwie.alipay.HouseList;
import com.bwie.alipay.service.AlipayService;
import com.bwie.common.domain.Order;
import com.bwie.common.result.Result;
import lombok.SneakyThrows;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@RestController
@RequestMapping("/alipay")
public class AlipayServiceImpl implements AlipayService {


    @Autowired
    private HouseList houseList;
    @Autowired
    private Alipay alipay;
    @SneakyThrows
    @Override
    public Result alipay(){
        Order order = new Order();
        order.setHouseId(houseList.getHouseId());
        order.setOrdersPrice(alipay.getOrdersPrice());
        AlipayConfig alipayConfig = new AlipayConfig();
        alipayConfig.setServerUrl(alipay.getServerUrl());
        alipayConfig.setAppId(alipay.getAppId());
        alipayConfig.setPrivateKey(alipay.getPrivateKey());
        alipayConfig.setAlipayPublicKey(alipay.getAlipayPublicKey());
        alipayConfig.setCharset(alipay.getCharset());
        alipayConfig.setSignType(alipay.getSignType());
        AlipayClient alipayClient = new DefaultAlipayClient(alipayConfig);
        AlipayTradePagePayRequest request = new AlipayTradePagePayRequest();
        request.setNotifyUrl(alipay.getNotifyUrl());
        request.setReturnUrl(alipay.getReturnUrl());
        AlipayTradePagePayModel model = new AlipayTradePagePayModel();
        String jsonString = JSON.toJSONString(order.getOrdersPrice());
        model.setTotalAmount(jsonString);
        String jsonString1 = JSON.toJSONString(order.getHouseId());
        model.setSubject(jsonString1);
        String sout = "2015";
        String our = RandomUtil.randomNumbers(13);
        String aa = sout+our;
        model.setOutTradeNo(aa);
        model.setProductCode("FAST_INSTANT_TRADE_PAY");
        request.setBizModel(model);
        order.setOrdersNumber(aa);

        AlipayTradePagePayResponse response = alipayClient.pageExecute(request, "GET");
        // 如果需要返回GET请求，请使用
        // AlipayTradePagePayResponse response = alipayClient.pageExecute(request, "GET");
        String pageRedirectionData = response.getBody();
        System.out.println(pageRedirectionData);
        if (response.isSuccess()) {
          return Result.success("调用成功!!!!!");
        } else {
            return Result.error("调用失败!!!!!");
        }
    }
}
