package com.bwie.ask.seriver.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.bwie.ask.mapper.AskBuyMapper;
import com.bwie.ask.seriver.AskBuyService;
import com.bwie.common.domain.AskBuy;
import com.bwie.common.result.Result;
import org.hibernate.validator.internal.util.stereotypes.Lazy;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 求购
 */
@Service
public class AskBuyServiceImpl extends ServiceImpl<AskBuyMapper, AskBuy> implements AskBuyService {


    private final AskBuyMapper askBuyMapper;


    public AskBuyServiceImpl(AskBuyMapper askBuyMapper) {
        this.askBuyMapper = askBuyMapper;
    }

    /**
     * 求购的普通链表
     * @return
     */
    @Override
    public Result<List<AskBuy>> shouAll(){
        List<AskBuy> askBuys = askBuyMapper.shouAll();
        return Result.success(askBuys);
    }
    @Override
    public Result addAskBuy(AskBuy askBuy){
        if(askBuy.getAskBuyAddress()==null || askBuy.getAskBuyAddress().equals("")){
            return Result.error("具体位置不能为空!!!!");
        }
        if(askBuy.getAskBuyTitle()==null || askBuy.getAskBuyTitle().equals("")){
            return Result.error("标签不能为空!!!!");
        }
        if(askBuy.getAskBuyPrice()==null || askBuy.getAskBuyPrice().equals("")){
            return Result.error("期望价格 不允许为空!!!!");
        }
        if(askBuy.getDictionaryTypeId()==null){
            return Result.error("求购类型不允许为空!!!!");
        }
        if(askBuy.getAddrId()==null){
            return Result.error("具体的省市县不允许为空!!!!");
        }
        Integer i = askBuyMapper.addAskBuy(askBuy);
        return Result.success(i>0?200:500,i>0?"发表成功!!!!":"发表失败!!!!");
    }





}
