package com.bwie.ask.seriver.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.bwie.ask.mapper.AskRentMapper;
import com.bwie.ask.seriver.AskRentService;
import com.bwie.common.domain.AskRent;
import com.bwie.common.result.Result;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 求租
 */
@Service
public class AskRentServiceImpl extends ServiceImpl<AskRentMapper, AskRent> implements AskRentService {

    private final AskRentMapper askRentMapper;

    public AskRentServiceImpl(AskRentMapper askRentMapper) {
        this.askRentMapper = askRentMapper;
    }

    /**
     * 求租的普通链表
     * @return
     */
    @Override
    public Result<List<AskRent>> shouList(){
        List<AskRent> askRentList = askRentMapper.shouList();
        return Result.success(askRentList);
    }


    @Override
    public Result addAskRent(AskRent askRent){
        if(askRent.getAskRentAddress()==null || askRent.getAskRentAddress().equals("")){
            return Result.error("具体位置不能为空!!!!");
        }
        if(askRent.getAskRentTitle()==null || askRent.getAskRentTitle().equals("")){
            return Result.error("标签不能为空!!!!");
        }
        if(askRent.getAskRentPrice()==null || askRent.getAskRentPrice().equals("")){
            return Result.error("期望价格 不允许为空!!!!");
        }
        if(askRent.getDictionaryTypeId()==null){
            return Result.error("求购类型不允许为空!!!!");
        }
        if(askRent.getAddrId()==null){
            return Result.error("具体的省市县不允许为空!!!!");
        }
        Integer i = askRentMapper.addAskRent(askRent);
        return Result.success(i>0?200:500,i>0?"发表成功!!!!":"发表失败!!!!");
    }

}
