package com.bwie.es.controller;

import com.bwie.common.domain.House;
import com.bwie.common.domain.request.HouseEsRequest;
import com.bwie.common.domain.request.HouseFindRequest;
import com.bwie.common.domain.request.ManagementRequest;
import com.bwie.common.result.PageResult;
import com.bwie.common.result.Result;
import com.bwie.es.service.EsListService;
import com.bwie.es.service.EsService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/es")
public class EsController {

    private final EsService esService;

    private final EsListService esListService;

    public EsController(EsService esService, EsListService esListService) {
        this.esService = esService;
        this.esListService = esListService;
    }

    @PostMapping("/list")
    public Result<PageResult<HouseEsRequest>> getEsList(@RequestBody HouseFindRequest req){
        return Result.success(
                esService.getEsList(req)
        );
    }
    @PostMapping("/managementSync")
    public void managementSync(@RequestBody List<House> list){
        esListService.managementSync(list);
    }

    @PostMapping("/managementList")
    public Result managementList(@RequestBody ManagementRequest managementRequest){
        return esListService.managementList(managementRequest);
    }

    @PostMapping("/printDocument")
    public House printDocument(String id) throws IOException {
        return esListService.printDocument(id);
    }


}
