package com.bwie.es.sync;

import com.bwie.common.domain.House;

import com.bwie.common.remote.RemoteHouseService;
import com.bwie.common.result.Result;
import com.bwie.es.service.EsListService;
import com.bwie.es.service.EsService;

//import com.xxl.job.core.handler.annotation.XxlJob;

import lombok.extern.log4j.Log4j2;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
@Log4j2

public class SyncHouseData {

    private final RemoteHouseService remoteHouseService;
    private final EsListService esService;

    public SyncHouseData(RemoteHouseService remoteHouseService,
                         EsService esService, EsListService esService1) {
        this.remoteHouseService = remoteHouseService;
        this.esService = esService1;
    }

//    @XxlJob("managementList")
    //    @Scheduled(cron = "0/5 * * * * ?")
//    public void buySync(){
//        Result<List<AskBuy>> listResult = askBuyRentFeign.shouAll();
//        List<AskBuy> data = listResult.getData();
//        if(data!=null){
//            esAskBuyService.shouList(data);
//        }
//        System.out.println("定时器求购正常启动!!!!!!");
//
//        Result<List<AskRent>> listResulta = askBuyRentFeign.shouList();
//        List<AskRent> dataa = listResulta.getData();
//        if(dataa!=null) {
//            esAskRentService.shouListt(dataa);
//        }
//        System.out.println("定时器求租正常启动!!!!!!");
//    }
    @Scheduled(cron = "0/5 * * * * ?")
    public void managementList(){
        Result<List<House>> shouall = remoteHouseService.shouall();
        List<House> data = shouall.getData();
        if(data!=null){
            esService.managementSync(data);
        }
        log.info("房源管理未卖出同步定时器启动>>>>>>>>>>");
    }

//    @XxlJob("syncHouseData")
//    public void syncHouseData(){
//        Result<List<HouseEsRequest>> houseEsList = remoteHouseService.getHouseEsList();
//        if (houseEsList.getData() != null){
//            esService.syncHouse(houseEsList.getData());
//        }
//        log.info("同步定时器启动>>>>>>>>>>");
//    }
}
