package com.bwie.esask;

import com.bwie.common.redis.RedisCache;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.Import;
import org.springframework.scheduling.annotation.EnableScheduling;

@SpringBootApplication
@EnableDiscoveryClient
@EnableFeignClients
@EnableScheduling
@MapperScan("com.bwie.esask.mapper")
@Import(value = {RedisCache.class})
public class EsAskApp {
    public static void main(String[] args) {
        SpringApplication.run(EsAskApp.class);
    }
}
