package com.bwie.home.controller;

import com.bwie.common.domain.House;
import com.bwie.common.domain.Order;
import com.bwie.common.domain.request.HouseEsRequest;
import com.bwie.common.result.Result;
import com.bwie.home.job.Reptile;
import com.bwie.home.service.HomeListService;
import com.bwie.home.service.HouseService;
import org.springframework.web.bind.annotation.*;

import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/home")
public class HouseController {

    private final HouseService houseService;

    private final HomeListService homeListService;
    private final Reptile reptile;
    public HouseController(HouseService houseService, HomeListService homeListService, Reptile reptile) {
        this.houseService = houseService;
        this.homeListService = homeListService;
        this.reptile = reptile;
    }

    @GetMapping("/list")
    public Result<List<HouseEsRequest>> getHouseEsList(){
        return Result.success(
                houseService.getHouseEsList()
        );
    }

    //添加订单表
    @PostMapping("/wayOrdersPayment")
    public Result wayOrdersPayment(@RequestBody Order order){
        return homeListService.wayOrdersPayment(order);
    }
    @GetMapping("/shouall")
    public Result<List<House>> shouall(){
        return homeListService.shouall();
    }

    @GetMapping("/addHouse")
    public Result<String> addHouse(@RequestParam String page) throws IOException {
        reptile.reptile(page);
        return Result.success();
    }

    @PostMapping("/addTwoHouse")
    public Result addTwoHouse(@RequestBody House house){
        return homeListService.addTwoHouse(house);
    }

    @GetMapping("/chaId")
    public Result<House> chaId(@RequestParam Integer houseId){
        return homeListService.chaId(houseId);
    }





}
