package com.bwie.home.job;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.bwie.common.domain.House;
import com.bwie.home.service.HouseService;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;

import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class Reptile {

    private final HouseService houseService;

    public Reptile(HouseService houseService) {
        this.houseService = houseService;
    }

    public List<House> reptile(String url) throws IOException {
        Document document = Jsoup.connect(url).get();

        ArrayList<House> list = new ArrayList<>();

        //获取第一层目录
        Elements elementsByClass = document.getElementsByClass("sellListContent");

        //便利第一层目录
        elementsByClass.stream().forEach(element -> {

            //获取每个元素
            for (Element byClass : element.getElementsByClass("clear")) {
                House houseEsRequest = new House();
                houseEsRequest.setUserId(1L);
                houseEsRequest.setHouseTypeId(1L);
                houseEsRequest.setDecorate("精装修");
                houseEsRequest.setBrokerId(1L);
                houseEsRequest.setVerify(0);
                houseEsRequest.setIsEs(0);
                houseEsRequest.setManagerStatus(1);
                houseEsRequest.setCreateTime(new Date());
                houseEsRequest.setIsDelete(0);
                houseEsRequest.setDictionaryTypeId(1);
                houseEsRequest.setSource("贝壳网");
                //获取图片元素
                for (Element aClass : byClass.getElementsByClass("lj-lazy")) {
                    //房型图片
                    String attr = aClass.attr("data-original");

                }
                for (Element aClass : byClass.getElementsByClass("info clear")) {
                    for (Element elements : aClass.getElementsByClass("title")) {
                        //常发豪庭国际一室满五精致舒适房 title
                        String name = elements.getElementsByClass("VIEWDATA CLICKDATA maidian-detail").text();
                        houseEsRequest.setTitle(name);
                    }

                    for (Element address : aClass.getElementsByClass("address")) {
                        for (Element positionInfo : address.getElementsByClass("positionInfo")) {
                            //地址
                            String text = positionInfo.getElementsByTag("a").text();
                            houseEsRequest.setHouseAddr(text);
                            houseEsRequest.setEstate(text);
                        }
                        String text = address.getElementsByClass("houseInfo").text();
                        String floods = text.replaceAll(" ", "");
                        //低楼层 (共6层) | 1987年 | 1室0厅 | 31.94平米 | 南
                        String[] split = floods.split("\\|");
                        houseEsRequest.setFloor(split[0]);
                        houseEsRequest.setRoomType(split[2]);
                        StringBuilder sb = new StringBuilder(split[3]);
                        sb.setLength(sb.length()-2);
                        Double acreage = Double.valueOf(sb.toString());
                        houseEsRequest.setAcreage(acreage);
                        houseEsRequest.setOrientation(split[4]);



                        for (Element tag : address.getElementsByClass("tag")) {
                            for (Element span : tag.getElementsByTag("span")) {
                                //标签

                            }
                        }

                        for (Element priceInfo : address.getElementsByClass("priceInfo")) {
                            for (Element totalPriceTotalPrice2 : priceInfo.getElementsByClass("totalPrice totalPrice2")) {
                                //价格
                                String text1 = totalPriceTotalPrice2.getElementsByTag("span").text();
                                houseEsRequest.setHousePrice(BigDecimal.valueOf(Double.valueOf(text1)));
                            }
                        }

                    }

                }
                list.add(houseEsRequest);
            }

        });

        List<House> collect = list.stream().distinct().collect(Collectors.toList());

        for (House house : collect) {
            List<House> serviceOne = houseService.list(new LambdaQueryWrapper<House>().eq(House::getTitle, house.getTitle()));
            if (serviceOne.isEmpty()){
                houseService.save(house);
            }
        }
        return list;

    }

}
