package com.bwie.home.job;

import cn.hutool.core.date.DateUtil;
import com.bwie.common.redis.RedisCache;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.stream.Collectors;

import static java.lang.Thread.sleep;

@Component
public class ReptileJob {

    private final RedisCache redisCache;
    private final Reptile reptile;

    public ReptileJob(RedisCache redisCache, Reptile reptile) {
        this.redisCache = redisCache;
        this.reptile = reptile;
    }

    @XxlJob("jsoupJob")
    public void getReptileJob() throws Exception {
        int pages = 0;
        Document document = Jsoup.connect("https://sh.ke.com/ershoufang/").get();
        for (Element content : document.getElementsByClass("content")) {
            for (Element leftContent : content.getElementsByClass("leftContent")) {
                for (Element elementsByClass : leftContent.getElementsByClass("page-box house-lst-page-box")) {
                    String attr = elementsByClass.attr("page-data");
                    String[] split = attr.split(",");
                    String[] split1 = split[0].split(":");
                    pages = Integer.parseInt(split1[1]);
                }
            }
        }
        ExecutorService executorService = Executors.newCachedThreadPool();
        System.out.println("-----------------------");
        final String url = "https://sh.ke.com/ershoufang/pg";
        List<String> list = null;
        for (int i = 1; i <= pages; i++) {
            final String bkUrl = "https://sh.ke.com/ershoufang/pg" + i;
            list = redisCache.redisTemplate.opsForList().range(url, 0, -1);
            List<String> collect = list.stream().filter(s -> s.equals(bkUrl)).collect(Collectors.toList());
            if (!collect.isEmpty()){
                continue;
            }
            executorService.execute(() -> {
                try {
                    reptile.reptile(bkUrl);
                    redisCache.redisTemplate.opsForList().rightPush(url, bkUrl);
                } catch (Exception e) {
                    throw new RuntimeException(e);
                }

            });

        }

    }
}
