package com.bwie.home.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.bwie.alipay.HouseList;
import com.bwie.common.domain.House;
import com.bwie.common.domain.Order;
import com.bwie.common.result.Result;
import com.bwie.home.feign.AlipayFeign;
import com.bwie.home.mapper.HomeListMapper;
import com.bwie.home.service.HomeListService;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class HomeListServiceImpl extends ServiceImpl<HomeListMapper,House> implements HomeListService {
    private final HomeListMapper listMapper;

    private final AlipayFeign alipayFeign;
    public HomeListServiceImpl(HomeListMapper listMapper, AlipayFeign alipayFeign) {
        this.listMapper = listMapper;
        this.alipayFeign = alipayFeign;
    }
    @Override
    public Result<List<House>> shouall(){
        List<House> list = listMapper.shouall();
        return Result.success(list);
    }

    @Override
    public Result addTwoHouse(House house){
       Integer i = listMapper.addTwoHouse(house);
       if(house.getImageAddr()==null){
           listMapper.addImage(house);
       }
       return Result.success(i>0?200:500,i>0?"发布成功!!!!":"发布失败!!!!!");
    }

    //支付订单
    @Override
    public Result wayOrdersPayment(Order order){
        Integer i = listMapper.addwayOrders(order);
        return Result.success(i>0?200:500,i>0?"订单添加成功":"订单添加失败!!!!!");
    }


    //查询内容
    @Override
    public Result<House> chaId(Integer houseId){
        House house = listMapper.chaId(houseId);
        HouseList houseList = new HouseList();
        houseList.setHouseId(house.getId());
        houseList.setOrdersPrice(house.getHousePrice());
        alipayFeign.alipay(houseList);
        if(house!=null){
            return Result.success(house,"对象传送成功!!!!!!!!!!");
        }
        return Result.error("查找的对象不存在,请重新尝试!!!!!!");
    }







}
