package com.bwie.user.controller;


import com.alibaba.nacos.shaded.org.checkerframework.checker.units.qual.A;
import com.bwie.common.domain.User;
import com.bwie.common.domain.request.LoginRequest;
import com.bwie.common.domain.request.UserRequest;
import com.bwie.common.result.Result;
import com.bwie.user.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.constraints.Past;

@RestController
public class UserController {


    @Autowired
    private  UserService userService;

    public UserController(UserService userService) {
        this.userService = userService;
    }


    @PostMapping("/login")
    public Result<User> login(@RequestBody LoginRequest loginRequest){

        return Result.success(
                userService.login(loginRequest)
        );
    }

    @PostMapping("register")
    public Result register(@RequestBody User user){
        userService.register(user);
        return Result.success();
    }

    @GetMapping("/findByPhone/{userTel}")
    public Result<User> findByPhone(@PathVariable("userTel") String userTel){
        return userService.findByPhone(userTel);
    }

    @PostMapping("/phoneLogin/{userTel}")
    public Result<User> phoneLogin(@PathVariable String  userTel){
        User user = userService.phoneLogin(userTel);

        return Result.success(user);
    }


}

