package com.bwie.user.service.impl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import com.bwie.common.domain.User;
import com.bwie.common.domain.request.LoginRequest;
import com.bwie.common.domain.request.UserRequest;
import com.bwie.common.result.Result;
import com.bwie.user.mapper.UserMapper;
import com.bwie.user.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class UserServiceImpl extends ServiceImpl<UserMapper,User> implements UserService {

    @Autowired
    private UserMapper userMapper;

    @Override
    public User login(LoginRequest loginRequest) {
        LambdaQueryWrapper<User> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(User::getUserName,loginRequest.getUserName())
                .eq(User::getUserPassword,loginRequest.getUserPwd());
        return this.getOne(queryWrapper);
    }

    @Override
    public void register(User user) {
        this.save(user);
    }

    @Override
    public Result<User> findByPhone(String userTel) {
        User user = this.getOne(new LambdaQueryWrapper<User>()
                .eq(User::getUserTel, userTel));
        return Result.success(user);
    }

    @Override
    public User phoneLogin(String userTel) {

        return userMapper.phoneLogin(userTel);
    }
}
